#include<bits/stdc++.h>
using namespace std;
long long a[100000005],b[100000005],l,r;
bool x;
int q;

int main ()
{
    int t,n[15],temp;
    cin >> t;
    for(int i=1; i<=t; i++)
    {
        cin >> n[i];
        for(int j=1; j<=n[i]; j++)
        {
            cin >> a[j];
            if(a[j]!=0)
            {
                l=j;
            }
        }

        for(int k=1; k<=n[i]; k++)
        {
            cin >> b[k];
            if(b[k]!=0)
            {
                r=k;
            }
        }

        if(abs(l-r)%2==0 and a[l]==b[r])
        {
            cout << "NE" << endl;
        }
        else
        {
            cout << "DA" << endl;
        }

    }
    return 0;
}